#!/bin/bash

C_FAJLOVI=$1;
#echo "C fajlovi: $C_FAJLOVI";

echo "${*:1}" | grep "k{\(.\{1,\}\)k}" -o | sed 's/k{//g' | sed 's/k}//g' > komarg.txt;
KOM_ARG=$(< komarg.txt);
#echo "Argumenti komandne linije: $KOM_ARG";

echo "${*:1}" | grep "u{\(.\{1,\}\)u}" -o | sed 's/u{//g' | sed 's/u}//g'  > stdin.txt;
STD_ULAZ=$(< stdin.txt);
#echo "Argumenti standardnog ulaza: $STD_ULAZ";

echo "${*:1}" | grep "i{\(.\{1,\}\)i}" -o | sed 's/i{//g' | sed 's/i}//g'  > ocekivani_izlaz.txt;

OCEKIVANI_IZLAZ=$(< ocekivani_izlaz.txt);
#echo "Ocekivani izlaz: $OCEKIVANI_IZLAZ";

# brisemo prethodni standardni izlaz ako postoji
if [ -f stdout.txt ]; then
	rm -f stdout.txt;
fi

# brisemo prethodni a.out ako postoji
if [ -f a.out ]; then
	rm -f a.out;
fi

# kompilacija
gcc "$C_FAJLOVI" -lm >& /dev/null

# ako se nije generisao a.out znaci da nije uspela kompilacija
if [ -f a.out ]; then
    # cekamo najvise 0.1 sekundu na izvrsavanje rezultata inace ubijamo ceo bash
    # standardni izlaz redirektujemo u stdout.txt a std gresku u /dev/null
    ./a.out "$KOM_ARG" < stdin.txt > stdout.txt 2> /dev/null & pid=$!;
    sleep 0.1;
    kill $pid &> /dev/null;
fi

DIFF="XXXX";
# Ako se izgenerisao izlaz
# Poredimo ocekivani i realizovani izlaz, pritom igornisemo beline i prazne redove
if [ -f stdout.txt ]; then
	# pre poredjenja eliminisemo nove redove
	# cistimo nove redove
	#cat ocekivani_izlaz.txt >> all.txt;
	#cat stdout.txt >> all.txt;
	#echo -e "\n" >> all.txt;
	sed ':a;N;$!ba;s/\n//g' ocekivani_izlaz.txt > ocekivani_izlaz1.txt;
        sed ':a;N;$!ba;s/\n//g' stdout.txt > stdout1.txt;
	#cat ocekivani_izlaz1.txt >> all.txt;
	#cat stdout1.txt >> all.txt;
	DIFF=$(diff -wB ocekivani_izlaz1.txt stdout1.txt);
	rm ocekivani_izlaz1.txt;
	rm stdout1.txt;
	#rm all.txt;
fi

# Brisanje svih generisanih fajlova
rm ocekivani_izlaz.txt;
if [ -f stdout.txt ]; then
	rm stdout.txt;
fi
rm stdin.txt;
rm komarg.txt;
if [ -f a.out ]; then
	rm a.out;
fi

#ne sme da bude nista vise od ovog jednog echa jer ga program koji ga poziva koristi kao rezultat
if [ "$DIFF" == "" ]; then
	echo "DA"; # prolazi test primer
else
	echo "NE"; # ne prolazi test primer
fi
